﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace LEDEdit
{
    public partial class Form1 : Form
    {
        Matrix1 WorkMatrix; //copy等取込用
        Matrix1 ViewMatrix;
        LEDMatrix StockMatrix; //保存用
        int SizeX, SizeY,MaxNum;
        int CellColor;
        int CellW, CellH; //BlockSize
        Boolean CellType;
        int SelectPage; //

        Boolean fAnimate;
        Boolean fMouseDown;

        public Form1()
        {
            InitializeComponent();
         
            SelectPage = 0;
            TB_Page.Text = SelectPage.ToString();
            //Dafault
            SizeX = 16;
            SizeY = 16;
            MaxNum = 1;
            CellW = 16;
            CellH = 16;
            CellColor = Color.Red.ToArgb();
            CellType = false;
            fMouseDown = false;

            WorkMatrix = new Matrix1(SizeX,SizeY,MaxNum);
            StockMatrix = new LEDMatrix(SizeX,SizeY,CellType,MaxNum,CellColor); 
            ViewMatrix = StockMatrix.GetMatrix(0);

            TS_CB_Zoom.SelectedIndex = 0;
        }

        private void BtAdd_Click(object sender, EventArgs e)
        {
            //AddPaturn
            ViewMatrix =StockMatrix.Add(SizeX,SizeY,MaxNum);
            SelectPage=StockMatrix.GetMaxPattern()-1;
            TB_Page.Text = SelectPage.ToString();
            pictureBox1.Refresh();
        }

        private void BtDel_Click(object sender, EventArgs e)
        {
            //delete selectPage
            if (SelectPage <= 0) return;
            StockMatrix.Remove(SelectPage);
            SelectPage--;
            TB_Page.Text = SelectPage.ToString();
            pictureBox1.Refresh();
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            //DefSize 16dot

            
            //DrawMatrix
            Graphics g = e.Graphics;
            Pen flame = SystemPens.ControlDarkDark;
            SolidBrush bFG = new SolidBrush( Color.FromArgb(CellColor)); //Fore
            SolidBrush bBG = new SolidBrush( Color.Black);   //Back
            
            //外枠

            for(int y=0 ; y < ViewMatrix.GetSizeY();y++)
            {
                for (int x = 0; x < ViewMatrix.GetSizeX();x++)
                {
                    //GlayBox BG.Black Fore
                    //ColorSelect
                    if (ViewMatrix.GetXY(x, y) != 0)
                    {
                        if (CB_Type.Checked)
                        {   
                            //circle
                            g.FillRectangle(bBG, x * CellW, y * CellH, CellW - 1, CellH - 1);
                            g.FillEllipse(bFG,   x * CellW, y * CellH, CellW - 1, CellH - 1);
                        }
                        else
                        {
                            //box
                            g.FillRectangle(bFG, x * CellW, y * CellH, CellW - 1, CellH - 1);
                        }
                    }
                    else
                    {
                        g.FillRectangle(bBG, x * CellW, y * CellH, CellW - 1, CellH - 1);
                    }
                    
                    g.DrawRectangle(flame, x * CellW, y * CellH, CellW - 1, CellH - 1);
                    
                 }
            }
            bFG.Dispose();
            bBG.Dispose();
            

            
        }
        private void SetCellSize()
        {
            switch (TS_CB_Zoom.SelectedIndex)
            {
                case 1:
                    CellW = 8;
                    CellH = 8;
                    break;
                case 2:
                    CellW = 16;
                    CellH = 16;
                    break;
                case 3:
                    CellW = 24;
                    CellH = 24;
                    break;
                case 4:
                    CellW = 32;
                    CellH = 32;
                    break;
                default:
                    //Auto
                    CellW = pictureBox1.Width / ViewMatrix.GetSizeX();
                    CellH = pictureBox1.Height / ViewMatrix.GetSizeY();
                    break;

            }

        }

        private void TS_CB_Zoom_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Repaint
            SetCellSize();
            pictureBox1.Refresh();
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            int sx, sy;
            fMouseDown = true;
            sx = e.X / CellW;
            sy = e.Y / CellH;
            ViewMatrix.PlusXY(sx, sy);
            pictureBox1.Refresh();
        }


        private void pictureBox1_Resize(object sender, EventArgs e)
        {
            SetCellSize();
            pictureBox1.Refresh();
        }

        private void BtAllOff_Click(object sender, EventArgs e)
        {
            ViewMatrix.Fill(0);
            pictureBox1.Refresh();
        }

        private void BtAllOn_Click(object sender, EventArgs e)
        {
            ViewMatrix.Fill(1);
            pictureBox1.Refresh();
        }

        private void RotU_Click(object sender, EventArgs e)
        {
            ViewMatrix.RotateUp();
            pictureBox1.Refresh();
        }

        private void RotD_Click(object sender, EventArgs e)
        {
            ViewMatrix.RotateDown();
            pictureBox1.Refresh();
        }

        private void RotL_Click(object sender, EventArgs e)
        {
            ViewMatrix.RotateLeft();
            pictureBox1.Refresh();
        }

        private void RotR_Click(object sender, EventArgs e)
        {
            ViewMatrix.RotateRight();
            pictureBox1.Refresh();
        }
        private void btRevH_Click(object sender, EventArgs e)
        {
            ViewMatrix.ReverseH();
            pictureBox1.Refresh();
        }

        private void btRevV_Click(object sender, EventArgs e)
        {
            ViewMatrix.ReverseV();
            pictureBox1.Refresh();
        }

        private void btAllPlus_Click(object sender, EventArgs e)
        {
            ViewMatrix.AllPlus();
            pictureBox1.Refresh();
        }

        private void BtRev_Click(object sender, EventArgs e)
        {
            //１コマ戻す
            //Store Page
            //StockMatrix.Replace(SelectPage, ViewMatrix);
            if (SelectPage < 1 ) return;

            //Load Page
            SelectPage--;
            TB_Page.Text = SelectPage.ToString();
            ViewMatrix = StockMatrix.GetMatrix(SelectPage);
            pictureBox1.Refresh();
        }

        private void BtFoward_Click(object sender, EventArgs e)
        {
            //1コマ進める
            //Store Page
            //StockMatrix.Replace(SelectPage, ViewMatrix);
            if (SelectPage >= (StockMatrix.GetMaxPattern()-1)) return;

            //Load Page
            SelectPage++;
            TB_Page.Text = SelectPage.ToString();
            ViewMatrix = StockMatrix.GetMatrix(SelectPage);
            pictureBox1.Refresh();
        }

        private void TS_Cut_Click(object sender, EventArgs e)
        {
            //Cut
            WorkMatrix.Copy(ViewMatrix);
            ViewMatrix.Clear();
            pictureBox1.Refresh();
        }

        private void TS_Copy_Click(object sender, EventArgs e)
        {
            //Copy
            WorkMatrix.Copy(ViewMatrix);
            pictureBox1.Refresh();
        }

        private void TS_Paste_Click(object sender, EventArgs e)
        {
            //Paste
            ViewMatrix.Copy(WorkMatrix);
            pictureBox1.Refresh();
        }

        private void TS_New_Click(object sender, EventArgs e)
        {
            //new
            Form2 settinfForm = new Form2();
            if (DialogResult.OK == settinfForm.ShowDialog())
            {
                //GetParam
                SizeX = settinfForm.GetSizeX();
                SizeY = settinfForm.GetSizeY();
                MaxNum = settinfForm.GetMaxNum();
                //CellColor = settinfForm.GetColor();
                //CellType = settinfForm.GetType();
                SelectPage = 0;

                //ResetClass
                StockMatrix.Clear();
                StockMatrix.Add(SizeX, SizeY, MaxNum);
                ViewMatrix = StockMatrix.GetMatrix(0);
                SetCellSize();
                pictureBox1.Refresh();
            }
            settinfForm.Dispose();
        }

        private void TS_Load_Click(object sender, EventArgs e)
        {
            //Load
            if (DialogResult.OK == openFileDialog1.ShowDialog())
            {
                StockMatrix.LoadCSV(openFileDialog1.FileName);
                ViewMatrix = StockMatrix.GetMatrix(SelectPage);
                CellColor = StockMatrix.Color;
                btColor.BackColor=Color.FromArgb(CellColor);

                pictureBox1.Refresh();
            }

        }

        private void TS_SaveCSV_Click(object sender, EventArgs e)
        {
            //SaveToCSV
            if (DialogResult.OK == saveFileDialog1.ShowDialog())
            {
                StockMatrix.SaveCSV(saveFileDialog1.FileName);
            }
        }

        private void Check_Click(object sender, EventArgs e)
        {
            //test
            OutText.Text+= "H1:" + ViewMatrix.ToHexHorison()  + "\r\n"
                        +  "H2:" + ViewMatrix.ToHexHorison2() + "\r\n"
                        +  "V1:" + ViewMatrix.ToHexVertical() + "\r\n"
                        +  "V2:" + ViewMatrix.ToHexVertical2()+ "\r\n";
            
        }

        private void BTstop_Click(object sender, EventArgs e)
        {
            //Stop
            fAnimate = false;
            timer1.Enabled = false;
        }

        private void BtPlay_Click(object sender, EventArgs e)
        {
            //Play
            fAnimate = true;
            timer1.Interval=int.Parse(TB_intarval.Text);
            timer1.Enabled = true;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            //animation
            SelectPage++;
            
            if (SelectPage >= StockMatrix.GetMaxPattern()) SelectPage = 0;
            ViewMatrix=StockMatrix.GetMatrix(SelectPage);
            TB_Page.Text = SelectPage.ToString();
            pictureBox1.Refresh();
        }

        private void CB_Type_CheckedChanged(object sender, EventArgs e)
        {
            //TypeChenge ReFresh
            pictureBox1.Refresh();
        }

        private void btColor_Click(object sender, EventArgs e)
        {
            //ColorChange
            if (DialogResult.OK == colorDialog1.ShowDialog())
            {
                btColor.BackColor = colorDialog1.Color;
                CellColor = colorDialog1.Color.ToArgb();
                StockMatrix.Color = CellColor;
                pictureBox1.Refresh(); 
            }
        }

        private void btPict_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //PicToPattern
                //適切サイズ算出し二値化する

                Bitmap img = new Bitmap(openFileDialog1.FileName);
                
                Bitmap wrk = new Bitmap(img,SizeX, SizeY);

                
                for(int y = 0; y < SizeY; y++)
                {
                    for (int x = 0; x < SizeX; x++)
                    {
                        if (0.5 < wrk.GetPixel(x, y).GetBrightness())
                        { ViewMatrix.SetXY(x, y, 1); }
                        else
                        { ViewMatrix.SetXY(x, y, 0); }
                                
                    }
                }
                //pictureBox1.Image = wrk;
                pictureBox1.Refresh();
            }
        }

                


    }
}
